vty-5.28.2: A simple terminal UI library

Safe Haskell | Safe
Language | Haskell2010

Graphics.Vty.DisplayAttributes

Synopsis

- fixDisplayAttr :: FixedAttr -> Attr -> FixedAttr
- data DisplayAttrDiff = DisplayAttrDiff {
  - styleDiffs :: [StyleStateChange]
  - foreColorDiff :: DisplayColorDiff
  - backColorDiff :: DisplayColorDiff
  - urlDiff :: URLDiff
  }
- simplifyStyleDiffs :: [StyleStateChange] -> [StyleStateChange] -> [StyleStateChange]
- simplifyColorDiffs :: DisplayColorDiff -> DisplayColorDiff -> DisplayColorDiff
- simplifyUrlDiffs :: URLDiff -> URLDiff -> URLDiff
- data DisplayColorDiff
  - = ColorToDefault
  - | NoColorChange
  - | SetColor !Color
- data StyleStateChange
  - = ApplyStandout
  - | RemoveStandout
  - | ApplyItalic
  - | RemoveItalic
  - | ApplyUnderline
  - | RemoveUnderline
  - | ApplyReverseVideo
  - | RemoveReverseVideo
  - | ApplyBlink
  - | RemoveBlink
  - | ApplyDim
  - | RemoveDim
  - | ApplyBold
  - | RemoveBold
- data URLDiff
  - = LinkTo !ByteString
  - | NoLinkChange
  - | EndLink
- displayAttrDiffs :: FixedAttr -> FixedAttr -> DisplayAttrDiff
- diffURL :: Maybe Text -> Maybe Text -> URLDiff
- diffColor :: Maybe Color -> Maybe Color -> DisplayColorDiff
- diffStyles :: Style -> Style -> [StyleStateChange]

# Documentation

fixDisplayAttr :: FixedAttr -> Attr -> FixedAttr Source #

Given the previously applied display attributes as a FixedAttr and the current display attributes as an Attr produces a FixedAttr that represents the current display attributes. This is done by using the previously applied display attributes to remove the KeepCurrent abstraction.

data DisplayAttrDiff Source #

difference between two display attributes. Used in the calculation of the operations required to go from one display attribute to the next.

Previously, vty would reset display attributes to default then apply the new display attributes. This turned out to be very expensive: A *lot* more data would be sent to the terminal than required.

Constructors

DisplayAttrDiff |

Fields

- styleDiffs :: [StyleStateChange]
- foreColorDiff :: DisplayColorDiff
- backColorDiff :: DisplayColorDiff
- urlDiff :: URLDiff

#### Instances

Instances details

Show DisplayAttrDiff Source # |
Instance details Defined in Graphics.Vty.DisplayAttributes Methods showsPrec :: Int -> DisplayAttrDiff -> ShowS show :: DisplayAttrDiff -> String showList :: [DisplayAttrDiff] -> ShowS
Semigroup DisplayAttrDiff Source # |
Instance details Defined in Graphics.Vty.DisplayAttributes Methods (<>) :: DisplayAttrDiff -> DisplayAttrDiff -> DisplayAttrDiff sconcat :: NonEmpty DisplayAttrDiff -> DisplayAttrDiff stimes :: Integral b => b -> DisplayAttrDiff -> DisplayAttrDiff
Monoid DisplayAttrDiff Source # |
Instance details Defined in Graphics.Vty.DisplayAttributes Methods mempty :: DisplayAttrDiff mappend :: DisplayAttrDiff -> DisplayAttrDiff -> DisplayAttrDiff mconcat :: [DisplayAttrDiff] -> DisplayAttrDiff

simplifyStyleDiffs :: [StyleStateChange] -> [StyleStateChange] -> [StyleStateChange] Source #

Used in the computation of a final style attribute change.

simplifyColorDiffs :: DisplayColorDiff -> DisplayColorDiff -> DisplayColorDiff Source #

Consider two display color attributes diffs. What display color attribute diff are these equivalent to?

simplifyUrlDiffs :: URLDiff -> URLDiff -> URLDiff Source #

Consider two URL changes, which are mostly going to be the latter unless the latter specifies no change.

data DisplayColorDiff Source #

Difference between two display color attribute changes.

Constructors

ColorToDefault |
NoColorChange |
SetColor !Color |

#### Instances

Instances details

Eq DisplayColorDiff Source # |
Instance details Defined in Graphics.Vty.DisplayAttributes Methods (==) :: DisplayColorDiff -> DisplayColorDiff -> Bool (/=) :: DisplayColorDiff -> DisplayColorDiff -> Bool
Show DisplayColorDiff Source # |
Instance details Defined in Graphics.Vty.DisplayAttributes Methods showsPrec :: Int -> DisplayColorDiff -> ShowS show :: DisplayColorDiff -> String showList :: [DisplayColorDiff] -> ShowS

data StyleStateChange Source #

Style attribute changes are transformed into a sequence of apply/removes of the individual attributes.

Constructors

ApplyStandout |
RemoveStandout |
ApplyItalic |
RemoveItalic |
ApplyUnderline |
RemoveUnderline |
ApplyReverseVideo |
RemoveReverseVideo |
ApplyBlink |
RemoveBlink |
ApplyDim |
RemoveDim |
ApplyBold |
RemoveBold |

#### Instances

Instances details

Eq StyleStateChange Source # |
Instance details Defined in Graphics.Vty.DisplayAttributes Methods (==) :: StyleStateChange -> StyleStateChange -> Bool (/=) :: StyleStateChange -> StyleStateChange -> Bool
Show StyleStateChange Source # |
Instance details Defined in Graphics.Vty.DisplayAttributes Methods showsPrec :: Int -> StyleStateChange -> ShowS show :: StyleStateChange -> String showList :: [StyleStateChange] -> ShowS

data URLDiff Source #

Constructors

LinkTo !ByteString |
NoLinkChange |
EndLink |

#### Instances

Instances details

Eq URLDiff Source # |
Instance details Defined in Graphics.Vty.DisplayAttributes Methods (==) :: URLDiff -> URLDiff -> Bool (/=) :: URLDiff -> URLDiff -> Bool
Show URLDiff Source # |
Instance details Defined in Graphics.Vty.DisplayAttributes Methods showsPrec :: Int -> URLDiff -> ShowS show :: URLDiff -> String showList :: [URLDiff] -> ShowS

displayAttrDiffs :: FixedAttr -> FixedAttr -> DisplayAttrDiff Source #

Determines the diff between two display&color attributes. This diff determines the operations that actually get output to the terminal.

diffURL :: Maybe Text -> Maybe Text -> URLDiff Source #

diffColor :: Maybe Color -> Maybe Color -> DisplayColorDiff Source #

diffStyles :: Style -> Style -> [StyleStateChange] Source #